<?php if (!defined('PLX_ROOT')) exit;
/**
 * Plugin plxAdminBar
 * @author Thomas Ingles
 * Thx FONTELLO
 **/
class plxAdminBar extends plxPlugin{
 public function __construct($default_lang){
  $this->default_lang = ( isset($_SESSION['admin_lang'])?$_SESSION['admin_lang'] : (isset($_SESSION['lang'])?$_SESSION['lang']:$default_lang) );//$_SESSION['admin_lang']:plx>=5.6
  $this->BASE_URL = '';//Gutuma fix (see admin-bar.php)
  parent::__construct($this->default_lang);# appel du constructeur de la classe plxPlugin (obligatoire) [avec la langue utilisateur]
  $this->href_plugin = (defined('PLX_GROOT') ? str_replace(PLX_ROOT,PLX_GROOT,PLX_PLUGINS) : PLX_PLUGINS).__CLASS__;//PLX_GROOT est pour le plugin gutuma
  $this->show = FALSE;
  if(!defined('PLX_ADMIN')){//Déclaration des hooks pour la partie visiteur
   if(isset($_SESSION['profil'])){
    $this->show = 'public';
    $this->addHook('Index', 'Index');// 2.0.0 active si bon site et utilisateur parm + connecté
    $this->addHook('ThemeEndHead', 'ThemeEndHead');
    $this->addHook('ThemeEndBody', 'ThemeEndBody');
   }
  }else{//admin only
   $this->addHook('AdminAuthPrepend', 'AdminAuthPrepend');// 2.0.0 AdminAuthPrepend Only if logon attempt
//show in admin
   if(isset($_SESSION['profil'])){
    $this->show = 'admin';
    $this->addHook('AdminTopEndHead', 'ThemeEndHead');// 2.0.0
    $this->addHook('AdminFootEndBody', 'ThemeEndBody');// 2.0.0
//Profil params
    $this->addHook('AdminPrepend', 'AdminPrepend');// 2.0.0
    $this->addHook('plxAdminEditProfil', 'plxAdminEditProfil');// 2.0.0
    $this->addHook('plxAdminEditUsersXml', 'plxAdminEditUsersXml');// 2.0.0
    $this->addHook('plxAdminEditUsersUpdate', 'plxAdminEditUsersUpdate');// 2.0.0
    $this->addHook('plxAdminEditUser', 'plxAdminEditUser');// 2.0.0
    $this->addHook('plxMotorGetUsers', 'plxMotorGetUsers');// 2.0.0
    $this->addHook('AdminProfilPrepend', 'AdminProfilPrepend');// 2.0.0
    $this->addHook('AdminProfil', 'AdminProfil');// 2.0.0
    $this->addHook('AdminUser', 'AdminProfil');// 2.0.0
    $this->addHook('AdminUsersFoot', 'AdminUsersFoot');// 2.0.0 (compatible 5.2 & 5.3)
   }
  }
 }
 public function AdminPrepend(){#V 2.0.0 Méthode appelée quand on du coté admin (affichage (admin) + MAJ parametres_users.php
  echo '<?php ';?>
  # parametres_users.php, update in mass : plxAdminBar, AdminPrepend
//fix changement de dossier media (plx 5.2) :: $_POST['selection'] is array
  if(isset($_POST['idUser']) AND isset($_POST['selection']) AND (strpos($_POST['selection'],'<?php echo __CLASS__ ?>') ==! FALSE)){
   $_POST['update'] = TRUE;
   $ab_mode = explode('_',$_POST['selection']);
   $ab_mode = $ab_mode[2];# adminBar mode selected : edit_users selector (parametres_users.php)
   foreach($_POST['idUser'] as $user_id){
    $plxAdmin->aUsers[$user_id]['<?php echo __CLASS__ ?>'] = $ab_mode;# For update user
   }
   # Chargement des fichiers de langue en fonction du profil de l'utilisateur connecté : *sont chargées après le hook ;)
   loadLang(PLX_CORE.'lang/'.$lang.'/admin.php');
   loadLang(PLX_CORE.'lang/'.$lang.'/core.php');

   $plxAdmin->editUsers($_POST);# *NEED : L_SAVE_SUCCESSFUL
   header('Location: parametres_users.php');
   exit;
  }
  #verif et affichage de la barre
  if(isset($plxAdmin->aUsers[$_SESSION['user']]) AND isset($plxAdmin->aUsers[$_SESSION['user']]['<?php echo __CLASS__ ?>'])){
   $_SESSION['<?php echo __CLASS__ ?>'] = $plxAdmin->aUsers[$_SESSION['user']]['<?php echo __CLASS__ ?>'];//parm profil adminBar
  }
?><?php
 }
 public function AdminUsersFoot(){#V 2.0.0 Méthode appelée quand on édite les utilisateurs du coté admin (parametres_users.php) : options au selecteur par js
  $arr = array('all'=>L_YES .' ('.L_ALL.')','admin'=>ltrim(L_ADMIN,'- '),'public'=>L_COMMENT_SITE_FIELD,'no'=>L_NO);
?>
<script type="text/javascript">
var arr = [];
<?php foreach($arr as $val => $txt)://all,admin,public,no ?>
arr.push(['<?php echo $val ?>','<?php echo $txt?>']);
<?php endforeach; ?>
var sel = document.getElementById('id_selection');//select
for (var i = 0; i < arr.length; i++) {
	var opt = document.createElement('option');
	opt.value = '_<?php echo __CLASS__ ?>_' + arr[i][0];
	opt.innerHTML = '<?php echo ucfirst(__CLASS__)?> &gt; ' + arr[i][1];
	//sel.insertBefore(opt, sel.childNodes[0]);//reverse & In 1st pos
	sel.appendChild(opt);
}
</script>
<?php
 }
 public function plxAdminEditProfil(){#V 2.0.0 Méthode appelée quand on édite son profil du coté admin
  echo '<?php ';?>
  $this->aUsers[$_SESSION['user']]['<?php echo __CLASS__ ?>'] = $content['<?php echo __CLASS__ ?>'];
?><?php
 }
 public function plxAdminEditUsersXml(){#V 2.0.0 Méthode appelée quand on du coté admin
  echo '<?php ';?>
  $xml .= "\t\t".'<<?php echo __CLASS__ ?>><![CDATA['.plxUtils::cdataCheck($user['<?php echo __CLASS__ ?>']).']]></<?php echo __CLASS__ ?>>'."\n";
?><?php
 }
 public function plxAdminEditUsersUpdate(){#V 2.0.0 Méthode appelée quand on sauve les utilisateurs : coté admin
  echo '<?php ';?>
  # user(s) / profil basic
  $this->aUsers[$user_id]['<?php echo __CLASS__ ?>'] = (isset($this->aUsers[$user_id]['<?php echo __CLASS__ ?>']) ? $this->aUsers[$user_id]['<?php echo __CLASS__ ?>'] : 'all');
?><?php
 }
 public function plxAdminEditUser(){#V 2.0.0 Méthode appelée quand on édite un utilisateur : coté admin
  echo '<?php ';?>
  $this->aUsers[$content['id']]['<?php echo __CLASS__ ?>'] = 'no';
  if($this->aUsers[$content['id']]['active']){
   $this->aUsers[$content['id']]['<?php echo __CLASS__ ?>'] = isset($content['<?php echo __CLASS__ ?>'])?$content['<?php echo __CLASS__ ?>']:'all';
   if($content['id'] == $_SESSION['user'])
    $_SESSION['<?php echo __CLASS__ ?>'] = $this->aUsers[$content['id']]['<?php echo __CLASS__ ?>'];
  }
?><?php
 }
 public function plxMotorGetUsers(){#V 2.0.0 Méthode appelée quand on du coté admin
  echo '<?php ';?>
  $this->aUsers[$number]['<?php echo __CLASS__ ?>']='no';//all,public,admin
  if($this->aUsers[$number]['active'] AND isset($iTags['<?php echo __CLASS__ ?>'][$i])){
   $this->aUsers[$number]['<?php echo __CLASS__ ?>'] = plxUtils::getValue($values[$iTags['<?php echo __CLASS__ ?>'][$i]]['value']);
   if($number == $_SESSION['user'])
    $_SESSION['<?php echo __CLASS__ ?>'] = $this->aUsers[$number]['<?php echo __CLASS__ ?>'];
  }
?><?php
 }
 public function AdminAuthPrepend(){#V 2.0.0 Pour être sur qu'il s'agit du bon site (MULTIPLE PLUXML IN SAME HOST) * @author Thomas Ingles
  echo '<?php '; ?>
  if(!empty($_POST)){//On login attempt only ::: $_POST['login'] $_POST['password']
   $_SESSION['racine<?php echo __CLASS__?>'] = $plxAdmin->aConf['racine'];//clef
  }
 ?><?php
 }
 public function AdminProfilPrepend(){#V 2.0.0 Méthode appelée quand on édite le profil coté admin et ajax (session menu toggler)
  echo '<?php ';?>
  if(isset($_GET['ajax<?php echo __CLASS__ ?>'])){//Ajax PHP, JS ou ...
   header('Pragma: no-cache');
   header('Content-Type: application/javascript');
   $_SESSION['ajax<?php echo __CLASS__ ?>'] = $_GET['ajax<?php echo __CLASS__ ?>'];//adapde le toggler (menu ouvert ou fermé)
   # echo 'console.log("Log AdminProfilPrepend : Session ajax<?php echo __CLASS__.time() ?> : '.$_SESSION['ajax<?php echo __CLASS__ ?>'].'");';
   exit();
  }
  if(isset($_POST['<?php echo __CLASS__ ?>']))
   $_profil['<?php echo __CLASS__ ?>'] = $_POST['<?php echo __CLASS__ ?>'];
?><?php
 }
 public function AdminProfil(){#V 2.0.0 Hook pour profil.php et user.php + AdminUser
?><img style="vertical-align:bottom" src="<?php echo $this->href_plugin ?>/icon.png">
	<fieldset class="withlabel">
		<div class="grid">
			<div class="field col sml-12"><label for="id_<?php echo __CLASS__ ?>"><?php echo ucfirst(__CLASS__) ?>&nbsp;:</label>
			
<?php
  echo '<?php ';?>
  $plxabVal = (isset($id) ? $plxAdmin->aUsers[$id]['<?php echo __CLASS__ ?>'] : $_profil['<?php echo __CLASS__ ?>']);
  plxUtils::printSelect('<?php echo __CLASS__ ?>', array('all'=>L_YES.' ('.L_ALL.')','admin'=>ltrim(L_ADMIN,'- '),'public'=>L_COMMENT_SITE_FIELD,'no'=>L_NO),$plxabVal);
?>
			</div>
		</div>
	</fieldset>
<?php
 }
 public function adminCss(){#V 2.0.0 Méthode appelée du coté admin
?>
	<link id="plxadminbar-nocache-css" defer rel="stylesheet" type="text/css" href="<?php echo $this->href_plugin ?>/css/admin-nocache.css?v=210" media="screen" />
<?php
 }
 public function adminJs($plxAdmin){#V 2.0.0 Méthode qui affiche le javascript pour déplacer la bare en premiere pos <body[0]> coté admin
?>
	<script type="text/javascript">
	if(window.name == '<?php echo L_MEDIAS_TITLE ?>'){//if is media manager popup
		document.getElementById('plxadminbar').style.display = 'none';//hide bar
		new Array('-nocache','-icon','').forEach(function(e){//plxadminbar links
			var ab_css = document.getElementById('plxadminbar'+e+'-css');//link id
			ab_css.parentNode.removeChild(ab_css);//remove
		});
	}
	function toggleMenu_ab(){//toggle admin pluxml main menu (aside)
		var toog = document.getElementById('plx-admin-bar-toggle-menu');
		var open = (toog.className.search("close") != -1);
<?php if(isset($plxAdmin->version) && $plxAdmin->version != '5.4'){//plx5.3.1 et en dessous ?>
		var menu = document.getElementById('sidebar');
		menu.style.display = menu.style.display=="none"?"block":"none";
		document.body.style = menu.style.display=="none"?"padding:0;":"";
		document.getElementById('content').style.padding = menu.style.display=="none"?"0":"0";
<?php }else{ ?>
		var menu = document.getElementsByClassName('aside');
		var plug = document.getElementsByTagName('section');
		var abar = document.getElementsByClassName('action-bar');
		var inav = document.getElementById('nav');//checkbox menu
		inav.checked = !open?false:true;
		abar[0].classList.toggle("fullwidth");
		plug[0].className = open?"section col sml-12 med-9 med-offset-3 lrg-10 lrg-offset-2":"section col sml-12 offsetfix plx-<?php echo str_replace('.','',$plxAdmin->aConf['version']) ?>";
		menu[0].style.display = open?"block":"none";
<?php } ?>
		toog.classList.toggle("close");
		var ajax_ab = document.createElement('SCRIPT');
		ajax_ab.id='plx-admin-bar-profil-ajax';
		document.body.appendChild(ajax_ab);
		ajax_ab.src='<?php echo $this->BASE_URL ?>profil.php?ajax<?php echo __CLASS__ ?>='+(open?'open':'close');//+'&d='+ new Date().getTime();//.getMilliseconds()
		window.setTimeout(function(){ajax_ab.parentNode.removeChild(ajax_ab)},111);
	}
<?php echo (@$_SESSION['ajax'.__CLASS__ ] == 'close' ? 'toggleMenu_ab();' : '');//autoclose ?>
	function <?php echo __CLASS__ ?>Init(){//init (new is's aside menu)
		var unem = document.getElementById('plx-admin-bar-site-name');
		var menu = unem.getElementsByTagName('LI');
		for(var m=0;m < menu.length-1;m++){
			var plg_mnu = (menu[m].id.search(/mnu_/)!==-1);
			if(plg_mnu) menu[m].id = '<?php echo __CLASS__ ?>_'+menu[m].id;//new mnu_ plugins menu id's
		}
	}
	<?php echo __CLASS__ ?>Init();
	</script>
<?php
  //$this->publicJs();
 }
 public function publicJs(){#V 2.0.0 Méthode qui affiche le javascript pour déplacer la bare en premiere pos <body[0]> coté public
?>
	<script type="text/javascript">
		var plxadminbar = document.getElementById('plxadminbar');
		document.body.id = !document.body.id ? 'indexadminbar': document.body.id;
		var b = document.getElementById(document.body.id);
		b.insertBefore(plxadminbar, b.childNodes[0]);  // Insert <div#plxadminbar> before the first child of <body>
	</script>
<?php
 }
 public function searchForm($mode='public',$plxMotor){#V 2.0.0 + Moteur De Recherche plxMySearch
  $plxPluginName = 'plxMySearch';
  ${$plxPluginName} = @$plxMotor->plxPlugins->aPlugins[$plxPluginName];
  if(${$plxPluginName}){
   $var = array();
   $var['mnuName'] =  ${$plxPluginName}->getParam('mnuName_'.$this->default_lang);
   $var['placeholder'] = ${$plxPluginName}->getParam('placeholder_'.$this->default_lang);
   $var['frmLibButton'] =  ${$plxPluginName}->getParam('frmLibButton_'.$this->default_lang);
   $var['checkboxes'] = ${$plxPluginName}->getParam('checkboxes_'.$this->default_lang);
   # initialisation des variables communes à chaque langue
   $var['url'] = $plxMotor->urlRewrite('?'.${$plxPluginName}->lang.${$plxPluginName}->getParam('url'));
   $var['method'] =  ${$plxPluginName}->getParam('method');
// <!-- MySearch Form -->
?>
        <form action="<?php echo $var['url']?>" id="adminbarsearch" method="<?php echo $var['method']?>" name="<?php echo $var['mnuName']?>">
          <input class="adminbar-input" id="adminbar-search" maxlength="150" name="searchfield" type="text" value="<?php echo @$_REQUEST['searchfield'] ?>" placeholder="<?php echo $var['placeholder']?>"/><label class="screen-reader-text" for="adminbar-search"><?php echo $var['frmLibButton']?></label>
          <input class="adminbar-button" type="submit" value="<?php echo $var['frmLibButton']?>" />&nbsp;
        </form>
<?php
  }
 }
 public function OnActivate(){#V 2.0.0 Méthode appelée quand on active le plugin
  $plxMotor = plxMotor::getInstance();
  $_SESSION['racine'.__CLASS__] = $plxMotor->aConf['racine'];//clef
 }
 public function OnDeactivate(){#V 2.0.0 Méthode appelée quand on desactive le plugin
  unset($_SESSION['racine'.__CLASS__]);//clef supprimée
 }
 public function OnUpdate(){#V 2.0.0 Méthode appelée quand on update le plugin (si fichier update présent a la racine du plugin)
  $plxMotor = plxMotor::getInstance();
  $_SESSION['racine'.__CLASS__] = $plxMotor->aConf['racine'];//clef
 }
 public function Index(){//V 2.0.0 Pour être sur qu'il s'agit du bon site (MULTIPLE PLUXML IN SAME HOST) * @author Thomas Ingles
  if(!isset($_SESSION[__CLASS__]) OR ($_SESSION[__CLASS__] != 'admin' OR $_SESSION[__CLASS__] != 'no')){
   echo '<?php '; ?>
   if(isset($_SESSION['profil']) AND ($plxMotor->aConf['racine'] == $_SESSION['racine<?php echo __CLASS__ ?>'])){//clef
    if(isset($_SESSION['save<?php echo __CLASS__ ?>'])){
     $_SESSION['<?php echo __CLASS__ ?>'] = $_SESSION['save<?php echo __CLASS__ ?>'];//$plxMotor->aUsers[$_SESSION['user']]['<?php echo __CLASS__ ?>'];
    }
   }
   else{//autres pluxmls on same host
    $_SESSION['save<?php echo __CLASS__ ?>'] = $_SESSION['<?php echo __CLASS__ ?>'];
    $_SESSION['<?php echo __CLASS__ ?>'] = 'no';
   }
?><?php
  }
 }
 public function ThemeEndHead(){//var_dump(__CLASS__.'->'.__FUNCTION__,$this->show);
  if(!isset($_SESSION[__CLASS__]) OR $_SESSION[__CLASS__]=='no') return;// if(!$this->show) return;
  if($this->show=='public' AND $_SESSION[__CLASS__]=='admin') return;//V 2.0.0 admin-nocache.css (retouches les tops)
  if($this->show=='admin' AND $_SESSION[__CLASS__]=='public') return;//V 2.0.0 admin-nocache.css (retouches les tops)
?>
<link id="plxadminbar-icon-css" defer rel="stylesheet" type="text/css" href="<?php echo $this->href_plugin ?>/css/dashicons.css?v=210" media="screen" />
<link id="plxadminbar-css" defer rel="stylesheet" type="text/css" href="<?php echo $this->href_plugin ?>/css/admin-bar.css?v=210" media="screen,print" />
<?php
  if($this->show=='admin') $this->adminCss();//V 2.0.0 admin-nocache.css (retouches les tops)
 }
 public function ThemeEndBody(){
  if(!isset($_SESSION[__CLASS__]) OR $_SESSION[__CLASS__]=='no') return;//if(!$this->show) return;
  if($this->show=='public' AND $_SESSION[__CLASS__]=='admin') return;//V 2.0.0 admin-nocache.css (retouches les tops)
  if($this->show=='admin' AND $_SESSION[__CLASS__]=='public') return;//V 2.0.0 admin-nocache.css (retouches les tops)
?>
<script type="text/javascript" id="plxAdminBar" src="<?php echo $this->href_plugin ?>/js/plxAdminBar.js?v=210"></script>
<?php
  $plxAdmin = plxMotor::getInstance();
  loadLang(PLX_CORE.'lang/'.$this->default_lang .'/admin.php');
  include_once('admin-bar.php');
  if($this->show=='admin')//defined('PLX_ADMIN'))
   $this->adminJs($plxAdmin);//V2.0.0 : [Admin] toggle menu (js)
  else
   $this->publicJs();//V2.0.0 : [Public] on la deplace au début de body (js)
 }
}
